#pragma once

#define ERROR_SUSIE_WIN32_EXCEPTION 0x80000000;
#define ERROR_SUSIE_PARAM_NOT_CORRECT 0x80000001;
#define ERROR_SUSIE_NOT_FUNCTION_POINTER 0x80000002;
#pragma once

#include<windows.h>
#include <time.h>
#include <tchar.h>

#include <pshpack1.h>
struct PictureInfo
{
	DWORD left,top;		//摜WJʒu
	DWORD width;		//摜̕(pixel)
	DWORD height;		//摜̍(pixel)
	WORD x_density;		//f̐x
	WORD y_density;		//f̐x
	WORD colorDepth;	//Pfbit
	HLOCAL hInfo;		//摜̃eLXg
};
#include <poppack.h>

typedef struct
{
	BYTE method[8];     //k@̎
	DWORD position;     //t@Cł̈ʒu
	DWORD compsize;     //kꂽTCY
	DWORD filesize;     //̃t@CTCY
	time_t timestamp;   //t@C̍XV
	char path[200];     //΃pX
	char filename[200]; //t@Cl[
	DWORD crc;          //CRC
} fileInfo;

typedef int (CALLBACK *GETPLUGININFO)(int,LPSTR,int);
typedef int (CALLBACK *GETPICTUREINFO)(void*,long,unsigned int,PictureInfo *);
typedef int (CALLBACK *ISSUPPORTED)(LPCSTR,void*);
typedef int (CALLBACK *GETPICTURE)(void*,long,unsigned int,HANDLE,HANDLE,FARPROC,long);
typedef int (CALLBACK *GETPREVIEW)(void*,long,unsigned int,HANDLE,HANDLE,FARPROC,long);
typedef int (CALLBACK *GETARCHIVEINFO)(void*, long, DWORD, HLOCAL *);
typedef int (CALLBACK *GETFILEINFO)(void*, long, LPSTR, DWORD, fileInfo *);
typedef int (CALLBACK *GETFILE)(LPCSTR, long, LPCSTR, unsigned int, FARPROC, long);
typedef int (CALLBACK *CONFIGURATIONDLG)(HWND hWnd, int fnc);

extern "C" int __stdcall GetPluginInfo(GETPLUGININFO fp, int infNo, LPSTR buf, int nBufLen);
extern "C" int __stdcall GetPictureInfo(GETPICTUREINFO fp, void* buf, long lBufLen, unsigned int flag, PictureInfo *lpInfo);
extern "C" int __stdcall IsSupported(ISSUPPORTED fp, const char * lpFileName, void *pMem);
extern "C" int __stdcall GetPicture(GETPICTURE fp, LPCSTR src, long len, unsigned int flag, HANDLE *pHBInfo,HANDLE *pHBm, FARPROC lpPrgressCallback,long lData);
extern "C" int __stdcall GetPreview(GETPREVIEW fp, LPCSTR src, long len, unsigned int flag, HANDLE *pHBInfo,HANDLE *pHBm, FARPROC lpProgressCallback,long lData);
extern "C" int __stdcall GetArchiveInfo(GETARCHIVEINFO fp, LPCSTR src, long lBufLen, unsigned int flag, HLOCAL *lpInfo);
extern "C" int __stdcall GetFileInfo(GETFILEINFO fp, LPSTR src, long lOffSet, LPSTR lpFileName, DWORD flag, fileInfo *lpFileInfo);
extern "C" int __stdcall GetFile(GETFILE fp, LPCSTR src,long len, LPCSTR dest,unsigned int flag, FARPROC progressCallback,long lData);
extern "C" int __stdcall ConfigurationDlg(CONFIGURATIONDLG fp, HWND parent, int fnc);


typedef struct tagFILE_TYPE_LIST
{
	std::vector<std::wstring> Exp;
	TCHAR FileTypeName[256];
	tagFILE_TYPE_LIST *pNext;
} FILE_TYPE_LIST;

typedef struct
{
	enum PLUGIN_TYPE
	{
		E_SUSIE_PICTURE,
		E_SUSIE_ARCHIVE,
	};
	PLUGIN_TYPE PluginType;
	char PluginName[MAX_PATH];
	char PluginCopyright[256];
	FILE_TYPE_LIST *SupportedFile;

	HINSTANCE hInstance;
	BOOL			bLoaded;
	GETPLUGININFO	fpGetPluginInfo;
	GETPICTUREINFO	fpGetPictureInfo;
	ISSUPPORTED		fpIsSupported;
	GETPICTURE		fpGetPicture;
	GETPREVIEW		fpGetPreview;
	GETARCHIVEINFO	fpGetArchiveInfo;
	GETFILE			fpGetFile;
	CONFIGURATIONDLG	fpConfigrationDlg;
} PluginInformation;

// Plugingq
static const TCHAR SUSIE_PLUGIN_EXT[] = _T(".SPI");
static const TCHAR PICTURE_EXPORT_PLUGIN_EXT[] = _T(".EPLG");
static const TCHAR PICTURE_IMPORT_PLUGIN_EXT[] = _T(".IPLG");
static const TCHAR PICTURE_FILTER_PLUGIN_EXT[] = _T(".FPLG");

